<?php
/*

Plugin Name: Instant SlideShare
Plugin URI: http://www.burcudogan.com/slideshare
Description: Use SlideShare's wordpress.com short embed tags in your own hosted Wordpress blog natively.
Version: 0.4
Author: Burcu Dogan
Author URI: http://www.burcudogan.com/


Usage: Copy and paste the Embed(wordpress.com) on slide pages into your posts.
You may prefer to add a "slideshare" class to your css files to style the objects.

--------------------------------
Plugin changed, to work with the wordpress.com embeed code on slideshare.

Old info is stated below...
* Version 0.2
* http://www.mikrosklave.net/?p=97
* Koen Verhaeghe
* http://blog.anabelamor.be

Plugin changed.
* removed SS_HEIGHT en SS_WIDHT in the param name section
* added str_replace to get rid of quotes

Version: 0.1
Author: Peter Weiland
Author URI: http://www.mikrosklave.net
Plugin based on J?Zaefferers YouTube-Plugin, see http://bassistance.de/index.php/2006/04/09/wordpress-youtube-plugin/
Installation: copy slideshare.php to the wp-content/plugins directory of your Wordpress installation, then activate the plugin. For embedding a slideshare object in a blog post enter
[slideshare id doc]
into the text area. Replace "id" and "doc" with the corresponding values from the URL of the object. For embedding the presentation at https://s3.amazonaws.com:443/slideshare/ssplayer.swf?id=4991&doc=ajaxworld-15351 you would enter [slideshare 4991 ajaxworld-15351]
If you decide to use the program, the following applies: This software is offered for use as is, and no warranty is stated or implied. The author is not responsible for any loss of data, damage to hardware nor any resulting loss of time or revenue resulting from the use of this program. Like all software, this program is utilised entirely at the user's risk.

*/
define("SS_ASPECT_RATIO",(348/425));
define("SS_REGEXP", "/\[slideshare ([[:print:]]+)\]/i");
define("SS_FLASH", '<span class="slideshare">'.
					'<object type="application/x-shockwave-flash" '.
						'data="http://static.slideshare.net/swf/ssplayer2.swf?{ss_info}" '.
						'width="{ss_width}" height="{ss_height}">'.
					'<param name="movie" value="http://static.slideshare.net/swf/ssplayer2.swf?{ss_info}" />'.
					'</object></span>');

function ss_plugin_callback($match)
{
	$output = SS_FLASH;
	
	$info = $match[1];
	$info = str_replace("&amp;", "&", $info);
	
	/** split parameters **/
	$info = split("&",$info);
	$ss_info = $info[0]."&amp;".$info[1];
	$width = str_replace("w=", "", $info[2]);
	
	$output = str_replace("{ss_info}", $ss_info, $output);
	
	/* calculate width and height */
	$height = round($width * SS_ASPECT_RATIO);
	$output = str_replace("{ss_width}", $width, $output);
	$output = str_replace("{ss_height}", $height, $output);
	
	return ($output);
}

function ss_plugin($content){
/* main function of the plugin */
	return (preg_replace_callback(SS_REGEXP, 'ss_plugin_callback', $content));
}


/* add filter to the content */
add_filter('the_content', 'ss_plugin');


?>
